#!/usr/bin/perl -w

#      +    
$area="./area";

#    
$config="/etc/bforce/sln_sfp.conf";





###############################################################################
### Programm ################################################### do't edit! ###
###############################################################################



### Parse config ##############################################################
open(CONF,"< $config") || die $!;
undef %sql;

while(<CONF>){
$sql{host}=$1	if /^sql_host\s+(\S+)$/i;
$sql{user}=$1	if /^sql_user\s+(\S+)$/i;
$sql{pass}=$1	if /^sql_pass\s+(\S+)$/i;
$sql{db}=$1	if /^sql_db\s+(\S+)$/i;
$sql{area}=$1	if /^sql_tb_area\s+(\S+)$/i;
$sql{ai}=$1	if /^tb_area_id\s+(\S+)$/i;
$sql{ap}=$1	if /^tb_area_path\s+(\S+)$/i;
$sql{aa}=$1	if /^tb_area_access\s+(\S+)$/i;
}

close(CONF);
die "Check SQL sets from config" if keys %sql != 8;



### Connect to MySQL server ###################################################
use DBI;
$dbh=DBI->connect("DBI:mysql:database=$sql{db};host=$sql{host}", $sql{user}, $sql{pass}) || $DBI::errstr;



### Areas #####################################################################
$i=0;(%path,%acc)=();
open(AR, "< $area") || die $!;
while(<AR>){
 if(/^(\S+)\s+(\d+)/){
  die "$1: $!" unless -d $1;
  $path{$i}=$1;$acc{$i}=$2;$i++;
 }
}
close(AR);

die "Area not defined" unless %path;




### Create table ##############################################################
$dbh->do("CREATE TABLE $sql{area}($sql{ai} smallint, $sql{ap} text, $sql{aa} tinyint)") || die $dbh->errstr;




### Insert areas ##############################################################
foreach(sort{$a<=>$b} keys %path){
    $dbh->do(sprintf("INSERT INTO $sql{area} VALUES($_,%s,$acc{$_})",$dbh->quote($path{$_}))) || die $dbh->errstr;
}



### End #######################################################################
print "Create table with areas successfully !\n";
