#!/usr/bin/perl -w

#    
$config="/etc/bforce/sln_sfp.conf";





###############################################################################
### Programm ################################################### do't edit! ###
###############################################################################



### Parse config ##############################################################
open(CONF,"< $config") || die $!;
undef %sql;

while(<CONF>){
$sql{host}=$1	if /^sql_host\s+(\S+)$/i;
$sql{user}=$1	if /^sql_user\s+(\S+)$/i;
$sql{pass}=$1	if /^sql_pass\s+(\S+)$/i;
$sql{db}=$1	if /^sql_db\s+(\S+)$/i;
$sql{area}=$1	if /^sql_tb_area\s+(\S+)$/i;
$sql{file}=$1	if /^sql_tb_file\s+(\S+)$/i;
$sql{ai}=$1	if /^tb_area_id\s+(\S+)$/i;
$sql{ap}=$1	if /^tb_area_path\s+(\S+)$/i;
$sql{aa}=$1	if /^tb_area_access\s+(\S+)$/i;
$sql{fi}=$1	if /^tb_file_id\s+(\S+)$/i;
$sql{ff}=$1	if /^tb_file_file\s+(\S+)$/i;
$sql{fd}=$1	if /^tb_file_desc\s+(\S+)$/i;
}

close(CONF);
die "Check SQL sets from config" if keys %sql != 12;


### Connect to MySQL server ###################################################
use DBI;
$dbh=DBI->connect("DBI:mysql:database=$sql{db};host=$sql{host}", $sql{user}, $sql{pass}) || $DBI::errstr;



### Areas #####################################################################
$sth=$dbh->prepare("SELECT $sql{ai},$sql{ap},$sql{aa} FROM $sql{area}");
$sth->execute() || $dbh->errstr;
die "No available area" unless $sth->rows;
(%path,%access)=();
while($_=$sth->fetch){
  $path{$_->[0]}=$_->[1];
$access{$_->[0]}=$_->[2];
}



### Get files #################################################################
print "Get all available files and description for this:\n";
foreach $path (sort {$a<=>$b} keys %path){
print "Work with $path{$path}... ";
 opendir(DIR,$path{$path}) || die "$path: $!";
  %$path=map {$_,getdesc("$path{$path}/$_")} grep {-f "$path{$path}/$_"} readdir(DIR);
 closedir(DIR);
print "ok  (".(keys %$path).")\n";
}





### Create table ##############################################################
$dbh->do("CREATE TABLE $sql{file}($sql{fi} smallint, $sql{ff} text, $sql{fd} text)") || die $dbh->errstr;





### Insert files ##############################################################
print "\nInserting into table:\n";
foreach $path (sort{$a<=>$b} keys %path){
print "Work with $path{$path}...";
foreach(keys %$path){
 $dbh->do(sprintf("INSERT INTO $sql{file} VALUES($path,%s,%s)",$dbh->quote($_),$dbh->quote($$path{$_}))) || die $dbh->errstr;
}
print " ok\n";
}



print "\nAll successfully !\n";
exit 0;








sub getdesc{

$_[0]=~s/(\W)/\\$1/g;

###############################################################################
############# description set result of exec `file` unix command ##############
###############################################################################

chomp($desc=`file -b $path{$path}/$_`);

###############################################################################
###############################################################################
###############################################################################

$desc;
}
