#!/usr/bin/perl -w

#    
$config="/etc/bforce/sln_sfp.conf";




###############################################################################
### Programm ################################################### do't edit! ###
###############################################################################

use Time::Local;
use DBI;

print "Please !RUN FROM SRIF COMPATIBLE MAILER!\n" and exit unless $ARGV[0];

$ver='FReq processor v0.4 [MySQL] (c) Sln !';







### Parse config ##############################################################
(%f,%addr,%alias,%sql,%err,$code,$note)=();

open(CFG, "< $config") || die "$config ($!)";
while($_=<CFG>){

$f{my}=$1	if /^my\s+([\d:\/\.]+)$/i;
$f{log}=$1	if /^log\s+(\S+)$/i;
$f{cps}=$1	if /^cps\s+(\d+)$/i;
$f{list}=$1	if /^list\s+(\d)$/i;
$f{prot}=$1	if /^prot\s+(\d)$/i;
$f{max}=$1	if /^max\s+(\d+)$/i;
$f{mask}=$1	if /^mask\s+(\d)$/i;

$code=$1	if /^recode\s+(\S+)$/i;
$note=$1	if /^notice\s+(\S+)$/i;

$addr{$1}=$2	if /^addr\s+([\d:\/\.\*]+)\s+(.+)$/i;
$alias{$1}=$2	if /^alias\s+(\S+)\s+(\S+)$/i;

$sql{host}=$1	if /^sql_host\s+(\S+)$/i;
$sql{user}=$1	if /^sql_user\s+(\S+)$/i;
$sql{pass}=$1	if /^sql_pass\s+(\S+)$/i;
$sql{db}=$1	if /^sql_db\s+(\S+)$/i;
$sql{area}=$1	if /^sql_tb_area\s+(\S+)$/i;
$sql{file}=$1	if /^sql_tb_file\s+(\S+)$/i;
$sql{log}=$1	if /^sql_tb_log\s+(\S+)$/i;
$sql{ai}=$1	if /^tb_area_id\s+(\S+)$/i;
$sql{ap}=$1	if /^tb_area_path\s+(\S+)$/i;
$sql{aa}=$1	if /^tb_area_access\s+(\S+)$/i;
$sql{fi}=$1	if /^tb_file_id\s+(\S+)$/i;
$sql{ff}=$1	if /^tb_file_file\s+(\S+)$/i;
$sql{fd}=$1	if /^tb_file_desc\s+(\S+)$/i;
#$sql{li}=$1	if /^tb_log_id\s+(\S+)$/i;
$sql{la}=$1	if /^tb_log_addr\s+(\S+)$/i;
$sql{ld}=$1	if /^tb_log_date\s+(\S+)$/i;
$sql{ls}=$1	if /^tb_log_size\s+(\S+)$/i;

$err{0}=$1	if /^err_req\s+(.+)$/i;
$err{1}=$1	if /^err_cps\s+(.+)$/i;
$err{2}=$1	if /^err_list\s+(.+)$/i;
$err{3}=$1	if /^err_prot\s+(.+)$/i;
$err{4}=$1	if /^err_max\s+(.+)$/i;
$err{5}=$1	if /^err_access\s+(.+)$/i;
$err{6}=$1	if /^err_limit\s+(.+)$/i;
$err{7}=$1	if /^err_found\s+(.+)$/i;

}
close CFG;

err("Can not get main param from config")    if keys %f != 7;
err("Can not get address param from config") if keys %addr < 1;
err("Can not get sql param from config")     if keys %sql != 16;
err("Can not get err param from config")     if keys %err != 8;

loging("Starting: $ver");





### Connect to MySQL server ###################################################

$dbh=DBI->connect("DBI:mysql:database=$sql{db};host=$sql{host}",$sql{user},$sql{pass}) || err("MySQL: $DBI::errstr");






### Loading/parsing recode file ###############################################

if($code){
 open(CODE, "< $code") || err("$code: $!");
  $in=$out='';
   while(<CODE>){ $in.="\\$1",$out.="\\$2" if /^0+(x[\da-f]+)\s+0+(x[\da-f]+)/i }
 close(CODE);
}






### Loading/parse srif-file ###################################################

undef %s;
open(SF, "< $ARGV[0]") || err("$ARGV[0]: $!");
while(<SF>){

$s{aka}=$1	if /^aka\s+([\d:\/\.]+)/i;
$s{req}=$1	if /^requestlist\s+(.+)/i;
$s{res}=$1	if /^responselist\s+(.+)/i;
$s{cps}=$1	if /^baud\s+(\d+)/i;
$s{list}=$1	if /^systemstatus\s+(.+)/i;
$s{prot}=$1	if /^remotestatus\s+(.+)/i;
$s{sysop}=$1	if /^sysop\s+(.+)/i;

}
close SF;

err("Can not get main param from srif-file") if keys %s != 7;

loging("System: $s{aka} ($s{sysop}, $s{cps}, $s{list}, $s{prot})");





### preset ####################################################################

(@send,@msg,%rf)=();
$totnum=$totsize=0;
mkmsg1("Request result:");
mkmsg1("-"x78);






### Check system ##############################################################

if($f{cps} != 0 and $f{cps} > $s{cps})            { mkmsg1($err{1}); goto fmsg1 }
if(lc($s{list}) eq "unlisted" and $f{list} == 0)  { mkmsg1($err{2}); goto fmsg1 }
if(lc($s{prot}) eq "uprotected" and $f{prot} == 0){ mkmsg1($err{3}); goto fmsg1 }






### Get request file ##########################################################

#$s{req}="log/req";

undef %rf;

open(RF, "< $s{req}") || err("$s{req}: $!");
 while(<RF>){ $rf{lc($1)}='' if /^([^\|\s]+)/ }
close RF;

unless(%rf){ mkmsg1($err{0}); goto fmsg1 }

loging("Freq files: ".(join " ", sort keys %rf));






### Get limits ################################################################
($z,$n,$f,$p)=split /[\.\/\:]/, $s{aka};
$p=0 unless $p;

$addr=undef;
$addr=$addr{"*"}           if exists $addr{"*"};
$addr=$addr{"$z:*/*.*"}    if exists $addr{"$z:*/*.*"};
$addr=$addr{"$z:$n/*.*"}   if exists $addr{"$z:$n/*.*"};
$addr=$addr{"$z:$n/$f.*"}  if exists $addr{"$z:$n/$f.*"};
$addr=$addr{"$z:$n/$f.$p"} if exists $addr{"$z:$n/$f.$p"};

unless($addr){ mkmsg1($err{2}); goto fmsg1 }

if($addr=~/^(\d+):(\d+)\s+(\d+):(\d+)\s+(\d+)\.(\d+)\.(\d+)/){
    if(time < timelocal(0,0,0,$5,$6-1,$7)){ $file=$1;$access=$3 }
    else{ $file=$2;$access=$4 }
}elsif($addr=~/^(\d+)\s+(\d+)/){ $file=$1;$access=$2 }
else{ err("Limit error for $s{aka}") }


loging("Access: $access, file: $file");


if($_=$dbh->selectrow_array(sprintf("
    SELECT sum($sql{'ls'})
    FROM $sql{'log'}
    WHERE $sql{'la'}=%s
    AND to_days(now())=to_days(from_unixtime($sql{'ld'}))",
    $dbh->quote($s{'aka'})))){ $file-=$_ }

loging("Today spent limit: $file");





### Work with aliases #########################################################

foreach(keys %alias){ if(exists $rf{lc($_)}){ delete $rf{lc($_)}; $rf{$alias{lc($_)}}='' } }





### Get files from sql table ##################################################

$q=undef;

foreach(map {$dbh->quote($_)} keys %rf){
 if($f{'mask'}){
  s/%/\\%/g; s/_/\\_/g; s/\?/_/g; s/\*/%/g;
  $ch="LIKE";
 }else{
  $ch="=";
 }
  $q ? ($q.=" OR $sql{ff} $ch $_") : ($q="$sql{ff} $ch $_");
}

$q.=" ORDER BY $sql{ff} LIMIT 200";
#                             ^^^
#                      recomended

$sth=$dbh->prepare("SELECT $sql{ff},$sql{fd},$sql{fi} FROM $sql{file} WHERE $q");
$sth->execute();

(%file,%desc,%id)=();

goto fmsg0 unless $sth->rows;

$i=0;
while($_=$sth->fetch){ ($file{$i},$desc{$i},$id{$i++})=($_->[0],$_->[1],$_->[2]) }






### Get areas from sql table ##################################################

undef $q;
foreach(values %id){ $q ? ($q.=" OR $sql{ai}=$_") : ($q="$sql{ai}=$_") }

$sth=$dbh->prepare("SELECT DISTINCT $sql{ap},$sql{aa},$sql{ai} FROM $sql{area} WHERE $q");
$sth->execute();

(%path,%access)=();

while($_=$sth->fetch){ ($path{$_->[2]},$access{$_->[2]})=($_->[0],$_->[1]) }






### Make results ##############################################################

foreach $id (sort{$file{$a} cmp $file{$b}} keys %file){

    # check file on disk
    mkmsg0(0,$file{$id},  '-',  '-',$access{$id{$id}},$err{7}), next unless ($size,$date)=(stat("$path{$id{$id}}/$file{$id}"))[7,9];

    # check access
    mkmsg0(1,$file{$id},$size,$date,$access{$id{$id}},$err{5}), next if $access{$id{$id}} > $access and -r "$path{$id{$id}}/$file{$id}";

    # check limits
    mkmsg0(1,$file{$id},$size,$date,$access{$id{$id}},$err{6}), next if $size > $file;

    # check maxfile
    mkmsg0(1,$file{$id},$size,$date,$access{$id{$id}},$err{4}), next if $f{max} != 0 and $totnum >= $f{max};

    # hmm... ok send
    mkmsg0(2,$file{$id},$size,$date,$access{$id{$id}},$desc{$id});
    push @send, "$path{$id{$id}}/$file{$id}";
        $totnum++;
	$file-=$size;
        $totsize+=$size;
}







### Not found files ###########################################################

fmsg0:

foreach $f (sort keys %rf){
($flag,$o)=(undef,$f);
$f=~s/(\W)/\\$1/g;

if($f{mask} == 1){ $f=~s/\\\*/.*/g; $f=~s/\\\?/.{1}/g }

foreach(values %file){ if(/^$f$/i){ $flag=1; last } }

mkmsg0(0,$o,'-','-','-',$err{7}) unless $flag;
}







### Footer ####################################################################

fmsg1:
mkmsg1("-"x78);
mkmsg1("Sended $totnum file(s) of ".(keys %rf)." request at $totsize byte(s)");
mkmsg1("Today left limit $file byte(s)");
mkmsg1("-"x78);

loging("Total sent $totnum file(s) at $totsize byte(s)");







### notice ####################################################################
if($note){
open(NOTE, "< $note") || err("$note: $!");
 while(<NOTE>){ chomp; mkmsg1($_) }
close NOTE;
}






### Make and write pkt ########################################################
loging("Make pkt file");

while(1){
 $pktname="/tmp/".sprintf("%lx",time-$$).".pkt";
 last unless -f $pktname;
}

open(PKT, "> $pktname") || err("$pktname: $!");
 print PKT mkpkt(join "\r",@msg);
close PKT;










### Write response list #######################################################

loging("Make response list");

open(RES, "> $s{res}") || err("$s{res}: $!");
 print RES "-$pktname\n";
 print RES map{"+$_\n"} @send;
close RES;









### Update limits #############################################################

if($totsize){
 loging("Update file limit");
 $dbh->do(sprintf("INSERT INTO $sql{log} VALUES(%s,unix_timestamp(),$totsize)",$dbh->quote($s{aka})));
}







### Return to mailer ##########################################################

loging("Exit (errorlevel=0)\n");
exit 0;












### Sub programms #############################################################

sub loging{
my @t=localtime();
open(LOG, ">>$f{log}") || die "$f{log}: $!";
 print LOG sprintf("%02d/%02d/%02d %02d:%02d:%02d",$t[3],$t[4],substr($t[5],-2),$t[2],$t[1],$t[0])." sfsql [$$] $_[0]\n";
close LOG;
}




sub mkmsg0{
my ($sts,$file,$size,$date,$acc,$desc)=@_;

 if(!$sts)       { loging("Skip: $file ($desc)") }
 elsif($sts == 1){ loging("Skip: $path{$id{$id}}/$file (acc: $acc, size: $size, err: $desc)") }
 elsif($sts == 2){ loging("Sent: $path{$id{$id}}/$file (acc: $acc, size: $size)") }

d2s(f2s($file).s2s($size).t2s($date),$desc);
}



sub mkmsg1{ d2s('',$_[0]) }


sub f2s{ substr($_[0],0,15)." "."."x(15-length $_[0]) }



sub s2s{ 
 if($_[0]=~/^\d+$/){ "."x(8-length $_[0])." $_[0] " }
 else{ "."x9 }
}



sub t2s{
 if($_[0]=~/^\d+$/){
  my @t=localtime($_[0]);
  sprintf("%02d-%02d-%02d ",$t[3],$t[4],substr $t[5],-2);
 }else{ ("."x9)." " }
}



sub d2s{
my ($line,$str)=@_;
  eval "\$str=~tr/$in/$out/" if $code;
  @dsc=split /[\n\r]/,$str;
    push @msg, $dsc[0] ? substr(($line.shift @dsc),0,79) : "";
    push @msg, substr((" "x35).$_,0,79) foreach (@dsc);
}





sub err{
 loging("$_[0]");
 loging("Exit (errorlevel=1)\n");
 exit 1;
}




sub mkpkt{
$body=shift;

@orig=split /[\:\/\.]/, $f{my};
@dest=split /[\:\/\.]/, $s{aka};
$orig[3]=0 unless $orig[3];
$dest[3]=0 unless $dest[3];

@time=localtime();
@month=("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

$header =pack("vvvvvvvvvvvvvA8vvvvvvvvvvVvvvvvvv",
	$orig[2],$dest[2],$time[5]+1900,$time[4],
	$time[3],$time[2],$time[1],$time[0],
	9600,    2,       $orig[1],$dest[1],
	1234,    '',	  $orig[0],$dest[0],
	0,       256,     1234,    1,
	$orig[0],$dest[0],$orig[3],$dest[3],
	0,       2,       $orig[2],$dest[2],
	$orig[1],$dest[1],1,       0);

$head =sprintf("%02d",$time[3])." $month[$time[4]] ".(substr $time[5],-2);
$head.="  ".sprintf("%02d:%02d:%02d",$time[2],$time[1],$time[0]);
$head.="\x00$s{sysop}\x00FREQ processor\x00result\x00";

$cluge ="\x01INTL $dest[0]:$dest[1]/$dest[2] $orig[0]:$orig[1]/$orig[2]\x0D";
$cluge.="\x01TOPT $dest[3]\x0D" if $dest[3];
$cluge.="\x01FMPT $orig[3]\x0D" if $orig[3];
$cluge.="\x01MSGID: $f{my} ".sprintf("%lx",time)."\x0D\x0D\x0A";

$footer="\x0D\x0D--- $ver\x0D\x00\x00\x00";

$header.$head.$cluge.$body.$footer;
}
